<?php
/**
 * Plugin Name: Daily Free Kindle Books
 * Plugin URI: http://freebooksplugin.com
 * Description: This plugin creates a widget that loads daily free Kindle books with your unique affiliate ID
 * Version: 1.0.1
 * Author: Jeremy Hendon
 * Author URI: http://freebooksplugin.com
 * License: GPL2
 */
 
class DailyFreeKindleBooksWidget extends WP_Widget
{
  function DailyFreeKindleBooksWidget()
  {
    $widget_ops = array('classname' => 'DailyFreeKindleBooksWidget', 'description' => 'This plugin creates a widget that loads daily free Kindle books with your unique affiliate ID' );
    $this->WP_Widget('DailyFreeKindleBooksWidget', 'Daily Free Kindle Books', $widget_ops);
  }
 
  function form($instance)
  {
    $instance = wp_parse_args( (array) $instance, array( 'title' => 'Free Kindle Books for Today', 'aff_id' => '', 'number_of_books' => 2, 'book_category' => 'Health' ) );
    $title = $instance['title'];
    $aff_id = $instance['aff_id'];
    $number_of_books = $instance['number_of_books'];
    $book_category = $instance['book_category'];
?>
  <p><label for="<?php echo $this->get_field_id('title'); ?>">Title: </label><input class="widefat" id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" value="<?php echo attribute_escape($title); ?>" /></p>
  <p><label for="<?php echo $this->get_field_id('aff_id'); ?>">Amazon Affiliate ID: </label><input class="widefat" id="<?php echo $this->get_field_id('aff_id'); ?>" name="<?php echo $this->get_field_name('aff_id'); ?>" type="text" value="<?php echo attribute_escape($aff_id); ?>" /></p>
  <p><label for="<?php echo $this->get_field_id('number_of_books'); ?>">Number of Books to Display: </label>
  	<select name="<?php echo $this->get_field_name('number_of_books'); ?>" id="<?php echo $this->get_field_id('number_of_books'); ?>" class="widefat">
  	<?php
  		$options = array(1,2);
  		foreach ($options as $option) {
  			echo '<option value="' . $option . '" id="' . $option . '"', $number_of_books == $option ? ' selected="selected"' : '', '>', $option, '</option>';
  		}
  	?>
  	</select>
  <p><label for="<?php echo $this->get_field_id('book_category'); ?>">Category of Books to Display: </label>
  	<select name="<?php echo $this->get_field_name('book_category'); ?>" id="<?php echo $this->get_field_id('book_category'); ?>" class="widefat">
  	<?php
  		$options = array('Health');
  		foreach ($options as $option) {
  			echo '<option value="' . $option . '" id="' . $option . '"', $number_of_books == $option ? ' selected="selected"' : '', '>', $option, '</option>';
  		}
  	?>
  	</select>
<?php
  }
 
  function update($new_instance, $old_instance)
  {
    $instance = $old_instance;
    $instance['title'] = $new_instance['title'];
    $instance['aff_id'] = $new_instance['aff_id'];
    $instance['number_of_books'] = $new_instance['number_of_books'];
    $instance['book_category'] = $new_instance['book_category'];
    return $instance;
  }
 
  function widget($args, $instance)
  {
    extract($args, EXTR_SKIP);
 
    echo $before_widget;
    $title = empty($instance['title']) ? ' ' : apply_filters('widget_title', $instance['title']);
 
    if (!empty($title))
      echo $before_title . $title . $after_title;
 
    // WIDGET CODE GOES HERE
	$aff_id = $instance['aff_id'];
	$number_of_books = $instance['number_of_books'];
	$book_category = $instance['book_category'];
	
	switch ($book_category) {
    case "Health":
    	$url = 'https://s3.amazonaws.com/free-books-plugin/free-kindle-health-books.txt';
        break;
    default:
    	$url = 'https://s3.amazonaws.com/free-books-plugin/free-kindle-health-books.txt';
	}

	$content = wp_remote_get( $url );
	$content_body = wp_remote_retrieve_body( $content );

	preg_match('/book1:(.*);/', $content_body, $url1_match);
	$url1 = "http://www.amazon.com/gp/product/" . $url1_match[1] . "?tag=" . $aff_id;

	preg_match('/book2:(.*);/', $content_body, $url2_match);
	$url2 = "http://www.amazon.com/gp/product/" . $url2_match[1] . "?tag=" . $aff_id;

	preg_match('/book3:(.*);/', $content_body, $url3_match);
	$url3 = "http://www.amazon.com/gp/product/" . $url3_match[1] . "?tag=" . $aff_id;

	preg_match('/image_url1:(.*);/', $content_body, $image_url1_match);
	$image_url1 = $image_url1_match[1];
	
	preg_match('/image_url2:(.*);/', $content_body, $image_url2_match);
	$image_url2 = $image_url2_match[1];

	preg_match('/image_url3:(.*);/', $content_body, $image_url3_match);
	$image_url3 = $image_url3_match[1];
	
    echo "<div style=\"padding: 5px; position: relative;\">";
    
    echo "<div style=\"margin: 0 auto 10px auto; padding: 0; width: 66%; text-align: center;\"><a href=\"" . $url1 . "\"><img src=\"" . $image_url1 . "\"></a><p style=\"clear: both; font-size: .8em; line-height: .9em;\"><a href=\"" . $url1 . "\">Click Here to get this book Free on Amazon</a></p></div>";

	if($number_of_books>=2)
    	echo "<div style=\"margin: 0 auto 10px auto; padding: 0; width: 66%; text-align: center;\"><a href=\"" . $url2 . "\"><img src=\"" . $image_url2 . "\"></a><p style=\"clear: both; font-size: .8em; line-height: .9em;\"><a href=\"" . $url2 . "\">Click Here to get this book Free on Amazon</a></p></div>";

	if($number_of_books==3)
	    echo "<div style=\"margin: 0 auto 10px auto; padding: 0; width: 66%; text-align: center;\"><a href=\"" . $url3 . "\"><img src=\"" . $image_url3 . "\"></a><p style=\"clear: both; font-size: .8em; line-height: .9em;\"><a href=\"" . $url3 . "\">Click Here to get this book Free on Amazon</a></p></div>";
	    
	echo "<p class=\"submit\" style=\"font-size: .7em; text-align: center;\">Submit a Book at <a href=\"http://freebooksplugin.com\">FreeBooksPlugin.com</a></p>";
	
	echo "</div>";

    echo $after_widget;
  }
 
}
add_action( 'widgets_init', create_function('', 'return register_widget("DailyFreeKindleBooksWidget");') );
?>